/****
 *
 * Exemplo: Uso Incorreto de Variveis Locais de
 *          Durao Fixa
 *
 * Seo: D.4.5
 *
 ****/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

/****
 *
 * StrEmMaiusculas(): Retorna um string correspondente ao
 *                    string recebido como parmetro com
 *                    todas as suas letras em maisculas
 *
 * Parmetro: str (entrada) - o string
 *
 * Retorno: Endereo do string correspondente ao string
 *          recebido como parmetro com todas as suas
 *          letras em maisculas. NULL, se ocorrer falha
 *          de alocao de memria.
 *
 ****/
char *StrEmMaiusculas(const char *str)
{
   char *maiusculas, *p;

      /* Tenta alocar um bloco e checa a alocao */
   if ( !(maiusculas = malloc(strlen(str) +1)) )
      return NULL; /* No houve alocao */

      /* Copia no array cada caractere do */
      /* string convertido por toupper()  */
   for (p = maiusculas; *p = toupper(*str); ++p, ++str) {
      ; /* Vazio */
   }

   return maiusculas;
}

int main(void)
{
   char *s1 = "Botafogo",
        *s2 = "Flamengo";

   printf("\n\"%s\" em maiusculas: \"%s\""
          "\n\"%s\" em maiusculas: \"%s\"\n",
          s1, StrEmMaiusculas(s1), s2, StrEmMaiusculas(s2));

   return 0;
}

/******************* Exemplo de Execuo ******************

"Botafogo" em maiusculas: "BOTAFOGO"
"Flamengo" em maiusculas: "FLAMENGO"

**********************************************************/
