/****
 *
 * Exemplo: Ponteiro Incrementado Apontar para Outro Endereo
 *
 * Seo: D.8.4
 *
 ****/

#include <stdio.h>
#include <string.h>

/****
 *
 * CopiaString2(): Esta funo imita strcpy()
 *
 * Parmetros: destino (sada) - o array que recebe
 *                               a cpia
 *             origem (entrada) - o string que  copiado
 *
 * Retorno: string contendo a cpia
 *
 ****/
char *CopiaString2(char *destino, const char *origem)
{
   char *inicio = destino;

   while (*destino++ = *origem++)
      ; /* Intencionalmente vazio */

   return inicio;
}

int main(void)
{
   char *p, str[30];

   CopiaString2(str, "bola");

   printf("\nString copiado: \"%s\"", str);

   p = CopiaString2(str, "Problema");

   printf("\nString copiado: \"%s\"", p);

   strcat(p, " com Tiranossauro Rex");

   printf("\nString concatenado: \"%s\"\n", p);

   return 0;
}

/******************* Exemplo de Execuo ******************

String copiado: "bola"
String copiado: "problema"
String concatenado: "problema com Tiranossauro Rex"

**********************************************************/
