/****
 *
 * Exemplo: Detectando Overflow
 *
 * Seo: D.11.1
 *
 ****/

#include <stdio.h>
#include <limits.h>

int AbsErrado(int x)
{
   return x < 0 ? -x : x;
}

int Abs(int x)
{
   if (x == INT_MIN) {
      printf("\nOcorrera' Overflow: x = %d\n", x);
      return x;
   }

   return x < 0 ? -x : x;
}

int main(void)
{
   int x = -5, y = INT_MIN;

   printf("\n>>>>> Usando AbsErrado() <<<<<\n\n");
   printf("Valor absoluto de %d: %d\n", x, AbsErrado(x));
   printf("Valor absoluto de %d: %d\n", y, AbsErrado(y));

   printf("\n>>>>> Usando Abs() <<<<<\n\n");
   printf("Valor absoluto de %d: %d\n", x, Abs(x));
   printf("Valor absoluto de %d: %d\n", y, Abs(y));

   return 0;
}

/******************* Exemplo de Execuo *******************

>>>>> Usando AbsErrado() <<<<<

Valor absoluto de -5: 5
Valor absoluto de -2147483648: -2147483648

>>>>> Usando Abs() <<<<<

Valor absoluto de -5: 5

Ocorrera' Overflow: x = -2147483648
Valor absoluto de -2147483648: -2147483648

***********************************************************/
