/****
 *
 * Exemplo: passing argument n of 'F' from incompatible
 *          pointer type
 *
 * Seo: D.19.4
 *
 ****/

#include <stdio.h>

void Troca(int *p1, int *p2)
{
   int aux = *p1;

   *p1 = *p2;
   *p2 = aux;
}

int main(void)
{
   double i = 2.5, j = 5.2;

   printf( "\n\t>>> ANTES da troca <<<\n"
           "\n\t    i = %f, j = %f\n", i, j );

   Troca(&i, &j);

   printf( "\n\t>>> DEPOIS da troca <<<\n"
           "\n\t    i = %f, j = %f\n", i, j );

   return 0;
}

/****************** Exemplo de Compilao ******************

warning: passing argument 1 of 'Troca' from incompatible
         pointer type
note: expected 'int *' but argument is of type 'double *'
warning: passing argument 2 of 'Troca' from incompatible
         pointer type
note: expected 'int *' but argument is of type 'double *'

***********************************************************/
/******************* Exemplo de Execuo *******************

        >>> ANTES da troca <<<

            i = 2.500000, j = 5.200000

        >>> DEPOIS da troca <<<

            i = 2.500002, j = 5.199997

***********************************************************/
